<template>
  <NuxtLayout :name="'auth'">
    <div class="w-full mx-12 max-w-xl lg:w-full lg:max-w-4xl bg-transparent flex">
      <div class="w-full lg:w-1/2 bg-white p-8 lg:rounded-bl-3xl shadow-xl mx-auto mb-10">
        <h1 class="text-4xl mb-8 text-center text-slate-900 lg:hidden">
          Aplikasi Manajemen PDF
        </h1>
        <DynamicForm :isLoading="isLoading" :fields="fields" :formTitle="formTitle" :submitName="submitName"
          :onSubmit="onSubmit" />
        <hr class="my-2" />
        <div class="mb-4 w-full flex">
          <div class="w-1/2">
            <span class="block">
              Already have account?
              <NuxtLink class="block text-blue-500" to="/login">Login</NuxtLink>
            </span>
          </div>
          <div class="w-1/2">
            <span class="block">
              <a class="block text-right text-yellow-500" href="#">Forgot password?</a>
            </span>
          </div>
        </div>
      </div>
      <div class="hidden lg:block p-8 lg:rounded-tr-3xl shadow-xl w-1/2 bg-slate-400 bg-blend-darken mt-10"
        style="background-image: url('/assets/img/auth/banner.jpg')">
        <h1 class="text-5xl text-slate-50">Aplikasi Manajemen PDF</h1>
      </div>
    </div>
  </NuxtLayout>
</template>

<script lang="ts">
interface formTemplate {
  email: string;
  password: string;
}

export default {
  data() {
    return {
      formTitle: "Register",
      submitName: "Register",
      isLoading: false,
      fields: [
        { id: "name", name: "Name", type: "name", value: "" },
        { id: "username", name: "Username", type: "username", value: "" },
        { id: "email", name: "Email", type: "email", value: "" },
        { id: "password", name: "Password", type: "password", value: "" },
        {
          id: "role", name: "Role", type: "select", value: "", options: [
            {
              name: 'Pilih Role',
              value: ''
            },
            {
              name: 'Pabrik',
              value: 'pabrik'
            },
            {
              name: 'Penjualan',
              value: 'penjualan'
            }
          ]
        },
      ],
    };
  },
  methods: {
    onSubmit(data: formTemplate) {
      this.isLoading = true;
      const toastStore = useToastStore();

      this.$api
        .post(`/user/`, data)
        .then((response) => {
          toastStore.showToast("Account created successfully", 'success')
          this.$router.push("/login");
        })
        .catch((error) => {
          const detail = error.response.data.detail;
          let message = "";
          if (detail[0].msg) {
            message = detail[0].msg;
          } else {
            message = detail;
          }
          console.log(message)
          toastStore.showToast(message, 'danger')
        }).finally(() => {
          this.isLoading = false;
        })
    },
  },
};
</script>
